SystemOrganization addCategory: #'Seaside-Troll'!

WAComponent subclass: #TRMain
	instanceVariableNames: 'inocuousMessage trollComments trollSignOff samples letsSeeWhatTheTrollHasToSay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Troll'!

!TRMain class methodsFor: 'as yet unclassified' stamp: 'NickAger 2/21/2012 22:59'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'troll'.
	application
		addLibrary: JQDeploymentLibrary;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator! !

!TRMain methodsFor: 'troll accessors' stamp: 'NickAger 2/22/2012 10:27'!
ifLetsSeeWhatTheTrollHasToSay: aBlock
	letsSeeWhatTheTrollHasToSay ifTrue: aBlock! !

!TRMain methodsFor: 'initialization' stamp: 'NickAger 2/22/2012 10:25'!
initialize 
	super initialize.
	
	letsSeeWhatTheTrollHasToSay := false.! !

!TRMain methodsFor: 'accessing' stamp: 'NickAger 2/21/2012 20:05'!
inocuousMessage
	^ inocuousMessage! !

!TRMain methodsFor: 'accessing' stamp: 'NickAger 2/21/2012 20:05'!
inocuousMessage: anObject
	inocuousMessage := anObject! !

!TRMain methodsFor: 'rendering' stamp: 'NickAger 2/22/2012 10:28'!
renderContentOn: html
	html div
		class: 'trollContainer';
		with: [
			self renderSteveJobsQuoteOn: html.
			self renderFormOn: html.

			self ifLetsSeeWhatTheTrollHasToSay: [
				self renderTrollResponseOn: html ] ]! !

!TRMain methodsFor: 'rendering' stamp: 'NickAger 2/22/2012 10:24'!
renderFormOn: html
	html form: [
		| selectId textId |
		textId :=  html nextId.
		
		html div: [
			html select
				id: (selectId := html nextId);
				list: self samples keys;
				onChange: (html jQuery ajax script: [ :s | s << (s jQuery id: textId) value: self inocuousMessage ]; serializeThis);
				callback: [ :value | self inocuousMessage: (self samples at: value) ] ].
			
		html div: [
			html  textArea 
				id: textId;
				rows: 10;
				columns: 75;
				on: #inocuousMessage of: self ].
		
		html break.
		html submitButton
			callback: [ letsSeeWhatTheTrollHasToSay := self inocuousMessage isEmptyOrNil not ];
			with: 'see what the troll has to say about that...' ].! !

!TRMain methodsFor: 'rendering' stamp: 'NickAger 2/22/2012 10:18'!
renderSteveJobsQuoteOn: html
	html blockquote
		class: 'quote';
		with: 'The axis today is not liberal and conservative, the axis is constructive-destructive....'.
		
	html div
		class: 'jobsSignature';
		with: 'Steve Jobs'! !

!TRMain methodsFor: 'rendering' stamp: 'NickAger 2/22/2012 10:18'!
renderTrollQuoteOn: html
	html blockquote
		class: 'quote';
		with: 'In Internet slang, a troll is someone who posts inflammatory, extraneous, or off-topic messages in an online community, such as an online discussion forum, chat room, or blog, with the primary intent of provoking readers into an emotional response or of otherwise disrupting normal on-topic discussion'! !

!TRMain methodsFor: 'rendering' stamp: 'NickAger 2/22/2012 10:55'!
renderTrollResponseOn: html
	| message |
	message := self inocuousMessage.	
	message isNil ifTrue: [ ^ self ]. 
	
	message := message replaceAll: Character cr with: $..
	message := message replaceAll: Character lf with: $ .
	message := message copyReplaceAll: '..' with: '.'.
	
	html div
		class: 'trollResponseContainer';
		with: [
			('.' split: message) do: [ :each |
				each isEmpty ifFalse: [
					html blockquote
						class: 'originalMessageQuote';
						with: each.
					html div
						class: 'trollComment';
						with: self trollComments atRandom ] ].
			
			html break.
			html div: self trollSignOff atRandom ].
	
	self renderTrollQuoteOn: html.	

! !

!TRMain methodsFor: 'accessing' stamp: 'NickAger 2/22/2012 09:09'!
samples
	^ samples ifNil: [
		samples := GRSmallDictionary new.
		samples at: 'select an innocuous text or enter a message below...' put: nil.
		samples at: 'I''d like to teach the world to sing' put: 'I''d like to build the world a home
And furnish it with love
Grow apple trees and honey bees
And snow white turtle doves.

I''d like to teach the world to sing
In perfect harmony
I''d like to hold it in my arms
And keep it company'.

	samples at: 'Favourite things' put: 'Raindrops on roses and whiskers on kittens
Bright copper kettles and warm woolen mittens
Brown paper packages tied up with strings
These are a few of my favorite things

Cream colored ponies and crisp apple streudels
Doorbells and sleigh bells and schnitzel with noodles
Wild geese that fly with the moon on their wings
These are a few of my favorite things'.

	samples at: 'Pharo''s mission' put: 'Pharo''s goal is to deliver a clean, innovative, free open-source Smalltalk environment. By providing a stable and small core system, excellent dev tools, and maintained releases, Pharo is an attractive platform to build and deploy mission critical Smalltalk applications.'.

	samples at: 'Ebony and Ivory' put: 'Ebony And ivory live together In perfect harmony 
Side by side On my piano keyboard, oh lord, why don''t we? 
We all know that people are the same where ever we go 
There is good and bad In ev''ryone, 
we learn to live, we learn to give 
each other what we need to survive together alive. 

Ebony and ivory live together in perfect harmony 
side by side on my piano keyboard, oh lord why don''t we? 
Ebony, ivory living in perfect harmony 
Ebony, Ivory, Ooh '.

	samples ]! !

!TRMain methodsFor: 'troll accessors' stamp: 'NickAger 2/22/2012 07:55'!
trollComments
	^ trollComments ifNil: [
		trollComments := #(
			'How many customers?'
			'Develop the development process!!'
			'refusing to see facts'
			'I could sell *hundreds* of those to customers, big companies, hosting inclusive 20.000 each'
			'Pharo/Seaside *is* the right tool if YOU WOULD DO THE RIGHT THINGS, not just bothering some class structure deep in Pharo'
			'Welcome in the *real world*'
			'Start thinking like business men!!'
			'I follow all changes, i know, what you are aiming at!! But - you''ve got the wrong priorities!!'
			'Modern architectures dont''t need to GC (or rarely). "Objects not created do not to be garbage collected!!"'
			'LVCC is able to post - jit, callback problem solved, MP-ready,'
			'"mouseOverHandler" is *absolutely* depreciated everywhere, iOS, Android AND Windows 8 ... tablet useforms dominate Desktop useforms more and more.'
			'Wrong development process'
			'This is modern software engineering!!'
			'VM freezes, virtual machine crashes, whatever'
			'Nobody likes the man who brings bad news. Sophocles, Antigone, Greek tragic dramatist (496 BC - 406 BC)'
			'What are you doing? Don''t know!!'
			'Good programmers migrate code, addon''s from one stable, consistent state to the other. These "stable states" are expressed in release numbers.'
			'Ok, if it helps you to understand, that unstable software is quite useless for anybody'
			'Doing the right thing, not just things right!!!!!!!!!!'
			'If the Roadmap is clear, the money is there. Always!! Rule of market!!'
			'IMHO, this tool should be tightly intergrated into Pharo, porting should be easy.'
			'Second problem is the "Liskov problem":

Let q(x) be a property provable about objects x of type T. Then q(y) should be provable for objects y of type S where S is a subtype of T.'
			'Times have changed. You are no longer free to choose your programming language.'
			'A few thousand man-years have been invested by Google already, no chance *ever* for any team to keep up with.'
			'Smalltalk rather has the structure of a human brain, neurons firing around, reacting to all sorts of events and data. Even for a psychologist it is impossible to say, what neuron did a wrong job, when the patient suffers from mental illness. That problem tries to address the Pharo team by giving the ball of ill neurons a clear hierarcy and new structure, so that responsbilities can be clearly addressed, parallel to the structure within the programmers and enterprise hierarchy.'
		)
		
		]! !

!TRMain methodsFor: 'troll accessors' stamp: 'NickAger 2/22/2012 08:43'!
trollSignOff
	^ trollSignOff ifNil: [
		trollSignOff := #(
			'tnx 4 understanding'
			'tnx for seeing reality'
			'happy hacking!!'
			'Have fun hacking'
			'Tnx 4 your funny comment!!'
			'Ok, facts are unwanted here. Away again!! :-)'
			'So far my report of "state of the art of software programming"'
			'feel inspired,')]! !

!TRMain methodsFor: 'updating' stamp: 'NickAger 2/22/2012 09:03'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot title: 'Trolls have nothing *constructive* to contribute'.
	
	TRLibrary default updateRoot: anHtmlRoot.! !

WAFileLibrary subclass: #TRLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Troll'!

!TRLibrary methodsFor: 'accessing' stamp: 'NickAger 2/22/2012 09:01'!
selectorsToInclude
	^ #(trollStyleCss)! !

!TRLibrary methodsFor: 'css' stamp: 'NickAger 2/22/2012 10:57'!
trollStyleCss
^ '
html {
font-family: Georgia, "Times New Roman", Times, serif
}
.trollContainer {
	padding: 0px 60px 20px 60px
}

blockquote.quote {
display: block;
padding: 20px 0px;
width: 450px;
font-style: italic;
}

blockquote.quote:before, blockquote.quote:after  {
color: #69c;
display: block;
font-size: 700%;
width: 50px;
}

blockquote.quote:before  {
content: "\201C";
height: 0;
margin-left: -0.55em;
}

blockquote.quote:after  {
content: "\201D";
height: 50px;
margin-top: -70px;
margin-left: 420px;
}

.trollResponseContainer {
	width: 550px;
	margin-top: 30px;
	padding: 10px;
	border-style: dashed;
	border-width: 1px;
	background-color: #F1F1F1;
}

.originalMessageQuote {
font-style: italic;
	border-left: solid 1px;
	border-colour: #69c;
	padding-left: 10px;
}

.trollComment {

}

.jobsSignature {
	width: 450px;
	text-align:right;
}
'! !
TRMain initialize!
